java-getSupportFragmentManager()。getFragments()显示编译时间

调用getFragments会显示编译时错误,并显示以下消息:

getSupportFragmentManager()。getFragments()只能从 在同一个库组中(groupId = com.android.support)

我在getFragments中导入了以下类:

import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.design.widget.BottomNavigationView;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.MenuItem;
import android.widget.Toast;

getFragments扩展了FragmentManager.java

我的项目模块级别getFragments文件如下:

apply plugin: 'com.android.application'

android {
    compileSdkVersion 25
    buildToolsVersion "25.0.2"
    defaultConfig {
        applicationId "com.mycompany.floatingdemo"
        minSdkVersion 16
        targetSdkVersion 25
        versionCode 1
        versionName "1.0"
        testInstrumentationRunner "android.support.test.runner.AndroidJUnitRunner"
        vectorDrawables.useSupportLibrary = true
    }
    buildTypes {
        release {
            minifyEnabled false
            proguardFiles getDefaultProguardFile('proguard-android.txt'), 'proguard-rules.pro'
        }
    }
}

dependencies {
    compile fileTree(dir: 'libs', include: ['*.jar'])
    androidTestCompile('com.android.support.test.espresso:espresso-core:2.2.2', {
        exclude group: 'com.android.support', module: 'support-annotations'
    })
    compile 'com.android.support:appcompat-v7:25.2.0'
    compile 'com.android.support:design:25.2.0'
    compile 'com.android.support:support-vector-drawable:25.2.0'
    testCompile 'junit:junit:4.12'
}

这是FragmentManager.java中方法getFragments的源代码。

/**
 * Get a list of all fragments that have been added to the fragment manager.
 *
 * @return The list of all fragments or null if none.
 * @hide
 */
@RestrictTo(LIBRARY_GROUP)
public abstract List<Fragment> getFragments();

我最近将Android Studio更新到了最新的稳定版本(2.3),并更新了Android Gradle插件。 我认为这可能是相关的,因为我之前从未见过此错误。

3个解决方案
18 votes

正如getFragments文档中所指出的那样,getFragments不是可用于应用程序的公共方法,而是支持库的内部实现细节,因此使用了添加的getFragments注释,以防止使用私有API。

您需要将代码更改为不使用getFragments,而仅使用公共API。

ianhanniballake answered 2020-08-01T14:07:22Z
6 votes

对于那些可能在其编码中使用getFragments()的用户,我替换了我的代码,以将backstack中的最后一个片段替换为此代码(我假设在onBackPressed()50中使用此代码,以根据currentFragment进行更改,假定所有片段都已添加到后堆栈中):

FragmentManager.BackStackEntry backStackEntryAt = getSupportFragmentManager().getBackStackEntryAt(getSupportFragmentManager().getBackStackEntryCount() - 1);
currentFragment = backStackEntryAt.getName();
Er. Kaushik Kajavadara answered 2020-08-01T14:07:42Z
3 votes

您可以使用(请确保使用25.2.0或更高版本)

supportFragmentManager.registerFragmentLifecycleCallbacks(object : FragmentManager.FragmentLifecycleCallbacks() {
    override fun onFragmentAttached(fm: FragmentManager?, f: Fragment?, context: Context?) {
        f?.let { fList.add(it) }
    }

    override fun onFragmentDetached(fm: FragmentManager?, f: Fragment?) {
        f?.let { fList.remove(it) }
    }

}, false) 

而不是使用getFragments()

user8192276 answered 2020-08-01T14:08:06Z
translate from https://stackoverflow.com:/questions/42572249/getsupportfragmentmanager-getfragments-shows-a-compile-time-error